

' Lunar Lander Original QuickBasic by Dave Ahl
' xblite version by dave@awfuldarkforest.com

CONSOLE

IMPORT "xio_s.lib"
IMPORT "xst_s.lib"
IMPORT "xsx_s.lib"
DECLARE FUNCTION Entry ()
DECLARE FUNCTION Result (v, t, f)

FUNCTION Entry ()
	' console setup
	hStdOut = XioGetStdOut ()
	XioSetConsoleBufferSize (hStdOut, 0, 25)
	XioClearConsole (hStdOut)
	
	' opening
	PRINT TAB (30); "LUNAR LANDER"
	PRINT " "
	a$ = INLINE$ ("Do you want instructions? (y)  ")
	PRINT
	IF a$ = "y" THEN GOSUB Instruct
	XioClearConsole (hStdOut)
	
	' reset variables
	t = 0 : h = 1200 : v = 50 : f = 150
	' the loop
	DO
		XioClearConsole (hStdOut)
		' plot the lander
		x = 26 + (2 * t)
		y = 21 - (h / 60)
		XioPutConsoleText (hStdOut, "><", x, y)
		' hud
		XioSetTextAttributes (hStdOut, 15 | 48)
		PRINT " TIME  HEIGHT  SPEED   FUEL  "
		XioSetDefaultColors (hStdOut)
		PRINT
		XioSetTextAttributes (hStdOut, 11 | 64)
		PRINT TAB (1); t; TAB (8); h; TAB (16); v; TAB (23); f
		XioSetDefaultColors (hStdOut)
		PRINT
		' draw the ground
		XioSetTextAttributes (hStdOut, 6 | 128)
		XioSetConsoleCursorPos (hStdOut, 1, 22)
		PRINT "______________________________________________________________________________"
		' input fuel burn
		XioSetDefaultColors (hStdOut)
		XioSetConsoleCursorPos (hStdOut, 6, 4)
		b$ = INLINE$ ("? ")
		b = DOUBLE (b$)
		IF f = 0 THEN b = 0
		IF b < 1 THEN b = 0
		IF b > 30 THEN b = 30
		IF b > f THEN b = f
		' calculate height
		v1 = v - b + 5
		f = f - b
		h = h - 0.5 * (v + v1)
		t = t + 1
		v = v1
		' hit the ground
		IF h < 1 THEN
			h = 0
			Result (v, t, f)
			EXIT DO
		END IF
		' run out of fuel
		IF f < 1 THEN
			f = 0
			PRINT " **** OUT OF FUEL ****"		':PRINT CHR$(7)+CHR$(7)+CHR$(7)+CHR$(7)+CHR$(7)
		END IF

	LOOP
	' the bitter end

' instructions
SUB Instruct
	XioClearConsole (hStdOut)
	PRINT
	PRINT " You are landing on the moon and and have taken over manual"
	PRINT " control 1200 feet above a good landing spot. You have a down-"
	PRINT " ward velocity of 50 feet/sec. 150 units of fuel remain."
	PRINT
	PRINT " Here are the rules that govern your APOLLO space-craft:"
	PRINT
	PRINT " (1) After each second the height, velocity, and remaining fuel"
	PRINT "     will be reported via DIGBY your on-board computer."
	PRINT " (2) After the report a '?' will appear. Enter the number"
	PRINT "     of units of fuel you wish to burn during the next"
	PRINT "     second. Each unit of fuel will slow your descent by"
	PRINT "     1 foot/sec."
	PRINT " (3) The maximum thrust of your engine is 30 feet/sec/sec"
	PRINT "    or 30 units of fuel per second."
	PRINT " (4) When you contact the lunar surface. your descent engine"
	PRINT "     will automatically shut down and you will be given a"
	PRINT "     report of your landing speed and remaining fuel."
	PRINT " (5) If you run out of fuel your second by second report"
	PRINT "     will continue until you contact the lunar surface."
	PRINT
	INLINE$ (" Press Enter to continue ")
END SUB

END FUNCTION

FUNCTION Result (v, t, f)
	PRINT
	PRINT " ***** CONTACT *****"
	PRINT
	PRINT " Touchdown at "; t; " seconds."
	PRINT " Landing velocity = "; v; " feet/sec."
	PRINT f; " units of fuel remaining."
	PRINT
	IF v < 11 THEN
		PRINT " Congratulations! A perfect landing!"
		PRINT " Your license will be renewed.............later."
	END IF
	IF v > 10 THEN
		IF v < 30 THEN PRINT " You blasted a huge crater !"
		IF v < 50 THEN PRINT " Your ship is a wreck !"
		IF v > 49 THEN PRINT " You totalled an entire mountain !"
		PRINT
	END IF
	IF v > 20 THEN PRINT " Your family will be notified..............by post."
	PRINT:PRINT
	a$ = INLINE$ (" Another mission? (y) ")
	IF a$ = "y" THEN
		Entry ()
	END IF

END FUNCTION
