'
' An xblite ftp library based on ftplib.x by Thomas Pfau
'
' Notes: - only PORT connection mode has been implemented
'        - callback function prototype is CallBack (GIANT, GIANT) ' (filesize, total bytes transferred)
'
PROGRAM	"xinftp" 
VERSION	"0.0001" 
CONSOLE

IMPORT	"xst" 
'IMPORT  "xsx"
IMPORT	"xin"
IMPORT  "wsock32"
'IMPORT  "xio"
IMPORT  "msvcrt"

TYPE SOCKSIN
  UNION
		SOCKADDR .sa
		SOCKADDR_IN .in
  END UNION
END TYPE

EXPORT
DECLARE FUNCTION XinFtp ()
DECLARE FUNCTION FtpConnect (serverName$, @socket)
DECLARE FUNCTION FtpLogin (user$, pass$, socket)
DECLARE FUNCTION FtpSendCmd (cmd$, expresp, socket, @response$)
DECLARE FUNCTION ReadResponse (c, socket, @response$, @response2$)
DECLARE FUNCTION FtpDir (file$, path$, socket)
DECLARE FUNCTION FtpXfer (file$, path$, socket, typ, mode) 
DECLARE FUNCTION FtpAccess (path$, typ, mode, socket, @socketdata)
DECLARE FUNCTION FtpOpenPort (socket, @socketdata, mode, dir)
DECLARE FUNCTION FtpRead (@buf$, max, socket)
DECLARE FUNCTION FtpNlst (outputfile$, path$, socket)
DECLARE FUNCTION FtpQuit (socket)
DECLARE FUNCTION FtpWrite (@buf$, len, socket)
DECLARE FUNCTION FtpGet (outputfile$, path$, mode, socket)
DECLARE FUNCTION FtpSize (path$, GIANT size, socket)
DECLARE FUNCTION FtpPut (inputfile$, path$, mode, socket)
DECLARE FUNCTION FtpDelete (file$, socket)
DECLARE FUNCTION FtpRename (src$, dst$, socket)
DECLARE FUNCTION FtpModDate (path$, @date$, max, socket)
DECLARE FUNCTION FtpPwd (@path$, max, socket)
DECLARE FUNCTION FtpRmdir (path$, socket)
DECLARE FUNCTION FtpCDUp (socket)
DECLARE FUNCTION FtpChdir (path$, socket)
DECLARE FUNCTION FtpMkdir (path$, socket)
DECLARE FUNCTION FtpSysType (@type$, max, socket)
DECLARE FUNCTION FtpSite (cmd$, socket)
DECLARE FUNCTION FtpLastResponse (@response$)
DECLARE FUNCTION FtpSetCallBack (addrCB)
DECLARE FUNCTION FtpEcho (fEcho)
DECLARE FUNCTION FtpSetFilesize (GIANT fs)
DECLARE FUNCTION FtpSetBytesTransferred (GIANT bt)
DECLARE FUNCTION FtpSetTimeout (usec)
END EXPORT
DECLARE FUNCTION cb (GIANT fs, GIANT xferred)
'
EXPORT
' FtpAccess() type codes 
$$FTPLIB_DIR = 1
$$FTPLIB_DIR_VERBOSE = 2
$$FTPLIB_FILE_READ = 3
$$FTPLIB_FILE_WRITE = 4

' FtpAccess() mode codes 
$$FTPLIB_ASCII = 'A'
$$FTPLIB_IMAGE = 'I'
$$FTPLIB_TEXT = $$FTPLIB_ASCII
$$FTPLIB_BINARY = $$FTPLIB_IMAGE

$$FTPLIB_BUFSIZ = 8192

$$FTPLIB_READ = 1
$$FTPLIB_WRITE = 2

END EXPORT

'
' ######################
' #####  Entry ()  #####
' ######################
'
'
' Simple FTP client example....
' RFC protocols apply:
' http://info.internet.isi.edu/in-notes/rfc/files/rfc412.txt
'	http://info.internet.isi.edu/in-notes/rfc/files/rfc640.txt
'	http://info.internet.isi.edu/in-notes/rfc/files/rfc691.txt
'	http://info.internet.isi.edu/in-notes/rfc/files/rfc775.txt
'	http://www.cis.ohio-state.edu/htbin/rfc/rfc959.html
'	http://info.internet.isi.edu/in-notes/rfc/files/rfc1545.txt
'	http://info.internet.isi.edu/in-notes/rfc/files/rfc1579.txt
'	http://info.internet.isi.edu/in-notes/rfc/files/rfc1635.txt
' http://info.internet.isi.edu/in-notes/rfc/files/rfc1639.txt
'
' All RFC protocol information texts can be found here:
' http://info.internet.isi.edu/in-notes/rfc/files/
'
FUNCTION XinFtp ()

	GIANT size
		
	SHARED timeout
	timeout = 1000

	Xin()		' initialize Xin library
	
	IF LIBRARY(0) THEN RETURN
	
	' ======= test code follows =========
	
	FtpEcho ($$TRUE)

	serverName$ = INLINE$("Enter FTP server name (ftp.server.com) :")
	
	IF FtpConnect (serverName$, @socket) THEN
		? "Unable to connect to "; serverName$
		GOTO getout
	ELSE 
		connected = $$TRUE
	END IF
	
	user$ = INLINE$("Enter Username :")
	pass$ = INLINE$("Enter Password :")

	IF FtpLogin (user$, pass$, socket) THEN
		? "Login failure\r\n" 
		GOTO getout
	ELSE
		loggedin = $$TRUE
	END IF

? "----------------------------------------------------"	
	FtpDir ("", "", socket)
? "----------------------------------------------------"	
	FtpNlst ("", "", socket)
? "----------------------------------------------------"	
	INLINE$ ("Press any key to continue")
	
	FtpSetCallBack (&cb())
	
	FtpSize ("winio.zip", @size, socket)
	? "Size of winio.zip is"; size; " bytes"
	
	FtpSetFilesize (size)
	
	FtpGet ("winio.zip", "winio.zip", $$FTPLIB_IMAGE, socket)
	
'	XstLoadString ("xinftp.x", @s$)
'	fs = LEN(s$)
'	? "Size of xinftp.x is"; fs; " bytes"
	FtpSetFilesize (fs)
	
	FtpPut ("xinftp.x", "xinftp.x", $$FTPLIB_IMAGE, socket)
	FtpSize ("xinftp.x", @size, socket)
	? "Size of xinftp.x is"; size; " bytes"	
	
	FtpRename ("xinftp.x", "axx.x", socket)
	FtpSize ("axx.x", @size, socket)
	? "Size of axx.x is"; size; " bytes"	
	
	FtpModDate ("axx.x", @date$, 8, socket)
	? "Mod date is "; date$
	
	FtpPwd (@path$, max, socket)
	? "Current directory is "; path$
	
	FtpDelete ("axx.x", socket)
	
	FtpSysType (@type$, 0, socket)
	? "System type is "; type$
	
	
getout:
	FtpQuit (socket)
	
	INLINE$ ("Press any key to quit")
	
END FUNCTION

FUNCTION FtpConnect (serverName$, @socket)
' FtpConnect - connect to remote server

	SHARED echo
	SHARED timeout
	HOST  host
	serverPort = 21
	block = timeout
	
	IF XinSocketOpen (@socket, 0, 0, 0) THEN
		? "FtpConnect: XinSocketOpen error"
		XinSocketClose (-1)
		RETURN $$TRUE
	END IF
	
	port = 0
	address$$ = 0
	IF XinSocketBind (socket, block, @address$$, @port) THEN
		? "FtpConnect: XinSocketBind error"
		XinSocketClose (-1)
		RETURN $$TRUE
	END IF

	XinHostNameToInfo (serverName$, @host)
	XinAddressNumberToString (host.address, @addr$)

	error = XinSocketConnectRequest (socket, 0, host.address, serverPort)
	IF error THEN
		? "FtpConnect: XinSocketConnectRequest error"
		XinSocketClose (-1)
		RETURN $$TRUE
	END IF

	DO UNTIL connected
		error = XinSocketConnectStatus (socket, block, @connected)
		IF error THEN
			? "FtpConnect: XinSocketConnectStatus error"
			XinSocketClose (-1)
			RETURN $$TRUE
		END IF
	LOOP
	
	IF ReadResponse ('2', socket, @response$, @response2$) THEN
		? "FtpConnect: ReadResponse error"
		RETURN $$TRUE
	END IF
	
	IF echo THEN
		IF response$ THEN ? response$
	END IF

END FUNCTION

FUNCTION FtpLogin (user$, pass$, socket)
' FtpLogin - log in to remote server

	IF FtpSendCmd ("USER " + user$, '3', socket, @response$) THEN
		IF response$ THEN
			IF response${0} = '2' THEN
				RETURN
			ELSE
				RETURN $$TRUE
			END IF
		END IF
	END IF
	
	RETURN FtpSendCmd ("PASS " + pass$, '2', socket, @response$)

END FUNCTION

FUNCTION FtpSendCmd (cmd$, expresp, socket, @response$)
' FtpSendCmd - send a command and wait for expected response

	SHARED lastResponse$
	SHARED echo
	SHARED timeout

	IFZ cmd$ THEN RETURN $$TRUE
	
	IF echo THEN ? cmd$
	
	block = timeout
	
	cmd$ = cmd$ + "\r\n"

	writebytes = LEN(cmd$)
	bytes = 0
	error = XinSocketWrite (socket, block, &cmd$, writebytes, 0, @bytes)
	IF error THEN
		? "FtpSendCmd: XinSocketWrite error"
		RETURN $$TRUE
	END IF
	
	ret = ReadResponse (expresp, socket, @response$, @response2$)
	IF ret THEN
		? "FtpSendCmd: ReadResponse error"
		IF response$ THEN 
			IF echo THEN ? response$
			lastResponse$ = response$
			RETURN ret
		END IF
	END IF
	
	IF echo THEN ? response$
	
	lastResponse$ = reponse$

END FUNCTION

FUNCTION ReadResponse (c, socket, @response$, @response2$)
' read a response from the server

	SHARED timeout

	response$ = NULL$(256)
	block = timeout
	bytes = 0
	error = 0
	
	DO UNTIL error
		error = XinSocketRead (socket, block, &response$, 256, 0, @bytes)
		IF error THEN 
			? "ReadResponse: XinSocketRead error"
			RETURN $$TRUE
		END IF
	LOOP UNTIL bytes

	IF response${3} = '-' THEN
		match$ = response$
		match${3} = ' '
		match${4} = '\0'
		match$ = CSIZE$(match$)
		response2$ = NULL$(256)
		
		DO
			bytes = 0
			DO UNTIL error
				bytes = 0
				error = XinSocketRead (socket, block, &response2$, 256, 0, @bytes)
				IF error THEN
					? "ReadResponse: XinSocketRead error"
					RETURN $$TRUE
				END IF
			LOOP UNTIL bytes
		LOOP UNTIL (match$ = LEFT$(response2$, 4))
	END IF
	
	response$ = TRIM$(CSIZE$(response$))
	response2$ = TRIM$(CSIZE$(response2$))
'	IF response2$ THEN ? "response2$="; response2$

	IF response${0} <> c THEN RETURN $$TRUE

END FUNCTION

FUNCTION FtpDir (file$, path$, socket)
' FtpDir - issue a LIST command and write response to output

	RETURN FtpXfer (file$, path$, socket, $$FTPLIB_DIR_VERBOSE, $$FTPLIB_ASCII) 

END FUNCTION

FUNCTION FtpXfer (localfile$, path$, socket, typ, mode) 
' FtpXfer - issue a command and transfer data

	SHARED echo
	SHARED GIANT bytes_transferred

	rv = 0
	bytes_transferred = 0

	IF localfile$ THEN
		ac$ = "w"
		IF (typ == $$FTPLIB_FILE_WRITE) THEN ac$ = "r"
		IF (mode == $$FTPLIB_IMAGE) THEN ac$ = ac$ + "b"
		local = fopen (&localfile$, &ac$)

		IFZ local THEN 
			? "FtpXfer: fopen error: "; localfile$
			RETURN $$TRUE
		END IF
	END IF
	
	IF FtpAccess (path$, typ, mode, socket, @socketdata) THEN
		? "FtpXfr: FtpAccess error"
		XinSocketGetStatus (socketdata, @remote, @syssocket, @syserror, @status, @socketType, @readbytes, @writebytes)
		IF remote THEN XinSocketClose (remote)
		IF socketdata THEN XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF	
	
	XinSocketGetStatus (socketdata, @remote, @syssocket, @syserror, @status, @socketType, @readbytes, @writebytes)

	IF typ == $$FTPLIB_FILE_WRITE THEN
		DO
			buf$ = NULL$($$FTPLIB_BUFSIZ)
			l = fread (&buf$, 1, $$FTPLIB_BUFSIZ, local)

			IF l > 0 THEN
				DO 
					c = FtpWrite (@buf$, l, remote)
				LOOP UNTIL c <> 0

				IF c < l THEN
					? "FtpXfer: FtpWrite short write: passed "; STRING$(l); " wrote "; STRING$(c)
					rv = $$TRUE
					EXIT DO
				END IF
			END IF
		LOOP UNTIL l <= 0
	ELSE
		DO
			buf$  = NULL$($$FTPLIB_BUFSIZ)
			l = FtpRead (@buf$, $$FTPLIB_BUFSIZ, remote)
			IF l > 0 THEN
				s$ = LEFT$(buf$, l)
				IF local THEN
					IF fwrite (&s$, 1, LEN(s$), local) <= 0 THEN
						? "FtpXfer: fwrite error: "; local
						rv = $$TRUE
						EXIT DO
					END IF
				ELSE
					IF printf (&"%s", &s$) = -1 THEN 
						? "FtpXfer: printf error", local
						rv = $$TRUE
						EXIT DO
					END IF
				END IF
			END IF
		LOOP WHILE l >= 0
	END IF
	
	IF local THEN
		fflush (local)
		fclose (local)
	END IF

	IF remote THEN 
		IF XinSocketClose (remote) THEN
			? "FtpXfer: XinSocketClose error"
		END IF
	END IF

	IF socketdata THEN
		IF XinSocketClose (socketdata) THEN
			? "FtpXfer: XinSocketClose error"
		END IF
	END IF

	IF ReadResponse ('2', socket, @response$, @response2$) THEN
		? "FtpConnect: ReadResponse error"
		RETURN $$TRUE
	END IF
	
	IF echo THEN
		IF response$ THEN ? response$
		IF response2$ THEN ? response2$
	END IF
	
	RETURN rv
	
END FUNCTION

FUNCTION FtpAccess (path$, typ, mode, socket, @socketdata)
' FtpAccess - return a handle for a data stream

  IF ((path$ == "") && ((typ == $$FTPLIB_FILE_WRITE) || (typ == $$FTPLIB_FILE_READ))) THEN
		? "Missing path argument for file transfer\r\n"
		RETURN $$TRUE
	END IF
	
	buf$ = "TYPE " + CHR$ (mode)
	
  IF (FtpSendCmd (buf$, '2', socket, @response$)) THEN
		RETURN $$TRUE
	END IF
	
  SELECT CASE (typ)
    CASE $$FTPLIB_DIR:
			buf$ = "NLST"
			dir = $$FTPLIB_READ

    CASE $$FTPLIB_DIR_VERBOSE:
			buf$ = "LIST" 
			dir = $$FTPLIB_READ

    CASE $$FTPLIB_FILE_READ:
			buf$ = "RETR" 
			dir = $$FTPLIB_READ

    CASE $$FTPLIB_FILE_WRITE:
			buf$ = "STOR"
			dir = $$FTPLIB_WRITE

    CASE ELSE: 
			? "Invalid open type"; typ; "\r\n" 
			RETURN $$TRUE
  END SELECT
	
	IF path$ THEN
		buf$ = buf$ + " " + path$
	END IF
	
	IF (FtpOpenPort (socket, @socketdata, mode, dir) == -1) THEN
		? "FtpAccess: FtpOpenPort error"
		RETURN $$TRUE
	END IF
	
	IF FtpSendCmd (buf$, '1', socket, @response$) THEN
		? "FtpAccess: FtpSendCmd error"
		XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF
	
	IF XinSocketAccept (socketdata, 20001, @remote, 0) THEN
		? "FtpAccess: XinSocketAccept error"
		XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF
	
END FUNCTION

FUNCTION FtpOpenPort (socket, @socketdata, mode, dir)
' FtpOpenPort - set up data connection

	SOCKSIN sin
	LINGER lng
	SHARED timeout
	
	block = timeout
	
	IF (dir != $$FTPLIB_READ) && (dir != $$FTPLIB_WRITE) THEN
		? "FtpOpenPort: Invalid direction "; dir
		RETURN $$TRUE
	END IF
	
	IF (mode != $$FTPLIB_ASCII) && (mode != $$FTPLIB_IMAGE) THEN
		? "FtpOpenPort: Invalid mode "; mode
		RETURN $$TRUE
	END IF
	
	IF XinSocketGetAddress (socket, @port, @address$$, @remote, @rport, @raddress$$) THEN
		? "FtpOpenPort: XinSocketGetAddress error"
		RETURN $$TRUE
	END IF
	
'	? "port      ="; port
'	? "address$$ ="; address$$
'	? "rport     ="; rport
'	? "raddress  ="; raddress$$
	
	error = XinSocketOpen (@socketdata, $$PF_INET, $$SOCK_STREAM, $$IPPROTO_TCP)
	IF error = -1 THEN
		? "FtpOpenPort: XinSocketOpen error"
		XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF
	
	on = 1
	IF XinSetSocketOption (socketdata, $$SOL_SOCKET, $$SO_REUSEADDR, &on, SIZE(on)) THEN
		? "FtpOpenPort: XinSetSocketOption error"
		XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF
	
	lng.l_onoff = 0
	lng.l_linger = 0
	IF XinSetSocketOption (socketdata, $$SOL_SOCKET, $$SO_LINGER, &lng, SIZE(lng)) THEN
		? "FtpOpenPort: XinSetSocketOption error"
		XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF
	
	port = 0
	IF XinSocketBind (socketdata, block, address$$, port) THEN
		? "FtpOpenPort: XinSocketBind error"
		XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF
	
	IF XinSocketListen (socketdata, block, 0) THEN
		? "FtpOpenPort: XinSocketListen error"
		XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF	
	
	IF XinSocketGetAddress (socketdata, @port, @address$$, @remote, @rport, @raddress$$) THEN
		? "FtpOpenPort: XinSocketGetAddress error"
		XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF

'	? "port      ="; port
'	? "address$$ ="; address$$
'	? "rport     ="; rport
'	? "raddress  ="; raddress$$	
	
	sin.in.sin_port = port
	sin.in.sin_addr = address$$
	
	cmd$ = "PORT "
	cmd$ = cmd$ + STRING$(sin.sa.sa_data[2]) + ","
	cmd$ = cmd$ + STRING$(sin.sa.sa_data[3]) + ","	
	cmd$ = cmd$ + STRING$(sin.sa.sa_data[4]) + ","	
	cmd$ = cmd$ + STRING$(sin.sa.sa_data[5]) + ","	
	cmd$ = cmd$ + STRING$(sin.sa.sa_data[0]) + ","	
	cmd$ = cmd$ + STRING$(sin.sa.sa_data[1])
	
	IF FtpSendCmd (cmd$, '2', socket, @response$) THEN
		? "FtpOpenPort: FtpSendCmd error"
		XinSocketClose (socketdata)
		RETURN $$TRUE
	END IF
	
END FUNCTION

FUNCTION FtpRead (@buf$, max, socket)
' FtpRead - read from a data connection

	SHARED FUNCADDR FtpCallBack (GIANT, GIANT)
	SHARED GIANT bytes_transferred
	SHARED GIANT filesize
	SHARED timeout

	bytes = 0
	block = timeout
	error = XinSocketRead (socket, block, &buf$, max, 0, @bytes)
	
	IF bytes THEN 
		IF FtpCallBack THEN
			bytes_transferred = bytes_transferred + bytes
			@FtpCallBack (filesize, bytes_transferred)
		END IF
		RETURN bytes
	ELSE
		RETURN error
	END IF

END FUNCTION

FUNCTION FtpNlst (outputfile$, path$, socket)
' FtpNlst - issue an NLST command and write response to output

	RETURN FtpXfer (outputfile$, path$, socket, $$FTPLIB_DIR, $$FTPLIB_ASCII)
	
END FUNCTION

FUNCTION FtpQuit (socket)
' FtpQuit - disconnect from remote

	FtpSendCmd ("QUIT", '2', socket, @response$)
	XinSocketClose (-1)

END FUNCTION

FUNCTION FtpWrite (@buf$, len, socket)
' FtpWrite - write to a data connection

	SHARED FUNCADDR FtpCallBack (GIANT, GIANT)
	SHARED GIANT bytes_transferred
	SHARED GIANT filesize
	SHARED timeout

	bytes = 0
	block = timeout
	error = XinSocketWrite (socket, block, &buf$, len, 0, @bytes)
	IF bytes THEN 
		IF FtpCallBack THEN
			bytes_transferred = bytes_transferred + bytes
			@FtpCallBack (filesize, bytes_transferred)
		END IF
		RETURN bytes
	ELSE
		RETURN error
	END IF

END FUNCTION

FUNCTION FtpGet (outputfile$, path$, mode, socket)
' FtpGet - issue a GET command and write received data to output

	RETURN FtpXfer (outputfile$, path$, socket, $$FTPLIB_FILE_READ, mode) 

END FUNCTION

FUNCTION FtpSize (path$, GIANT size, socket)
' FtpSize - determine the size of a remote file

	SHARED GIANT filesize
	size = 0
	
	cmd$ = "TYPE " + CHR$($$FTPLIB_IMAGE)
	
	IF FtpSendCmd (cmd$, '2', socket, @response$) THEN
		? "FtpSize: FtpSendCmd error"
		RETURN $$TRUE
	END IF
	
	cmd$ = "SIZE " + path$
	
	IF FtpSendCmd (cmd$, '2', socket, @response$) THEN
		? "FtpSize: FtpSendCmd error"
		RETURN $$TRUE
	ELSE
		x = INSTR (response$, " ")
		IFZ x THEN 
			? "FtpSize: unable to return file size"
			RETURN $$TRUE
		END IF
		size$ = MID$(response$, x)
		size = GIANT(size$)
		filesize = size
	END IF

END FUNCTION

FUNCTION FtpPut (inputfile$, path$, mode, socket)
' FtpPut - issue a PUT command and send data from input

	RETURN FtpXfer (inputfile$, path$, socket, $$FTPLIB_FILE_WRITE, mode) 
	
END FUNCTION

FUNCTION FtpDelete (file$, socket)
' FtpDelete - delete a file at remote

	IFZ file$ THEN RETURN $$TRUE

	cmd$ = "DELE " + file$
	
	IF FtpSendCmd (cmd$, '2', socket, @response$) THEN
		? "FtpDelete: FtpSendCmd error"
		RETURN $$TRUE
	END IF

END FUNCTION

FUNCTION FtpRename (src$, dst$, socket)

	IFZ src$ THEN RETURN $$TRUE
	IFZ dst$ THEN RETURN $$TRUE
	
	cmd$ = "RNFR " + src$
	IF FtpSendCmd (cmd$, '3', socket, @response$) THEN
		? "FtpRename: FtpSendCmd error"
		RETURN $$TRUE
	END IF
	
	cmd$ = "RNTO " + dst$
	IF FtpSendCmd (cmd$, '2', socket, @response$) THEN
		? "FtpRename: FtpSendCmd error"
		RETURN $$TRUE
	END IF	

END FUNCTION

FUNCTION FtpModDate (path$, @date$, max, socket)
' FtpModDate - determine the modification date of a remote file

	IFZ path$ THEN RETURN $$TRUE
	
	cmd$ = "MDTM " + path$
	IF FtpSendCmd (cmd$, '2', socket, @response$) THEN
		? "FtpModDate: FtpSendCmd error"
		RETURN $$TRUE
	END IF
	
	date$ = ""

	IF response$ THEN
		IF max THEN
			date$ = MID$ (response$, 5, max)
		ELSE
			date$ = MID$ (response$, 5)
		END IF
		RETURN
	END IF
	
	RETURN $$TRUE

END FUNCTION

FUNCTION FtpPwd (@path$, max, socket)
' FtpPwd - get working directory at remote

	IF FtpSendCmd ("PWD", '2', socket, @response$) THEN
		? "FtpPwd: FtpSendCmd error"
		RETURN $$TRUE
	END IF
	
	x = INSTR (response$, "\"")
	IF x THEN
		y = INSTR (response$, "\"", x+1)
		IF y THEN
			path$ = MID$(response$, x+1, y-x-1)
			IF path$ THEN RETURN
		END IF
	END IF

	RETURN $$TRUE

END FUNCTION

FUNCTION FtpRmdir (path$, socket)
' FtpRmdir - remove directory at remote

	IFZ path$ THEN RETURN $$TRUE
	cmd$ = "RMD " + path$
	
	IF FtpSendCmd (cmd$, '2', socket, @response$) THEN
		? "FtpRmdir: FtpSendCmd error"
		RETURN $$TRUE
	END IF

END FUNCTION

FUNCTION FtpCDUp (socket)
' FtpCDUp - move to parent directory at remote

	IF FtpSendCmd ("CDUP", '2', socket, @response$) THEN
		? "FtpCDUp: FtpSendCmd error"
		RETURN $$TRUE
	END IF
	
END FUNCTION

FUNCTION FtpChdir (path$, socket)
' FtpChdir - change path at remote

	IFZ path$ THEN RETURN $$TRUE
	
	buf$ = "CWD " + path$
	IF FtpSendCmd (buf$, '2', socket, @response$) THEN
		? "FtpChdir: FtpSendCmd error"
		RETURN $$TRUE
	END IF

END FUNCTION

FUNCTION FtpMkdir (path$, socket)
' FtpMkdir - create a directory at server

	IFZ path$ THEN RETURN $$TRUE

	buf$ = "MKD " + path$
	IF FtpSendCmd (buf$, '2', socket, @response$) THEN
		? "FtpMkdir: FtpSendCmd error"
		RETURN $$TRUE
	END IF

END FUNCTION

FUNCTION FtpSysType (@type$, max, socket)
' FtpSysType - send a SYST command

	IF FtpSendCmd ("SYST", '2', socket, @response$)
		? "FtpSysType: FtpSendCmd error"
		RETURN $$TRUE
	END IF
	
	type$ = ""
	
	IF response$ THEN
		IF max THEN 
			type$ = MID$ (response$, 5, max)
		ELSE
			type$ = MID$ (response$, 5)
		END IF
		RETURN
	END IF
	
	RETURN $$TRUE

END FUNCTION

FUNCTION FtpSite (cmd$, socket)
' FtpSite - send a SITE command

	c$ = "SITE " + cmd$
	IF FtpSendCmd (c$, '2', socket, @response$) THEN
		? "FtpSite: FtpSendCmd error"
		RETURN $$TRUE
	END IF
	
END FUNCTION

FUNCTION FtpLastResponse (@response$)

SHARED lastResponse$
	response$ = lastResponse$

END FUNCTION

FUNCTION FtpSetCallBack (addrCB)
' set user callback function to monitor bytes read/write

SHARED FUNCADDR FtpCallBack (GIANT, GIANT)

	FtpCallBack = addrCB

END FUNCTION

FUNCTION FtpEcho (fEcho)
' if fEcho is $$TRUE, print commands sent and any responses
SHARED echo
	echo = fEcho

END FUNCTION

FUNCTION FtpSetFilesize (GIANT fs)
' set filesize for callback function
SHARED GIANT filesize

	filesize = fs

END FUNCTION

FUNCTION FtpSetBytesTransferred (GIANT bt)
' intialize or set bytes transferred for callback function
SHARED GIANT bytes_transferred

	bytes_transferred = bt
END FUNCTION

FUNCTION cb (GIANT fs, GIANT xferred)

IF fs THEN 
	? fs, xferred, (xferred/DOUBLE(fs))*100.0
END IF

END FUNCTION

FUNCTION FtpSetTimeout (usec)
' set blocking timeout in usec
'	timeout < 1			: timout = 0				' do not block
'	timeout < 10		: timeout = 10			' min block = 10us
'	timeout > 20000	: timeout = 20000		' max block = 20ms
	SHARED timeout
	
	timeout = usec

END FUNCTION

END PROGRAM
